﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;

namespace _12268
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        FarPoint.Win.Spread.FpSpread m_fpSpread;
         FarPoint.Win.Spread.SheetView m_fpSpread_Sheet;
        private void Form1_Load(object sender, EventArgs e)
        {
            //初始化打印控件
            m_fpSpread = new FarPoint.Win.Spread.FpSpread();
            m_fpSpread_Sheet = new FarPoint.Win.Spread.SheetView();
            ((System.ComponentModel.ISupportInitialize)m_fpSpread).BeginInit();
            ((System.ComponentModel.ISupportInitialize)m_fpSpread_Sheet).BeginInit();
            m_fpSpread.AccessibleDescription = "";
            m_fpSpread.BorderCollapse = FarPoint.Win.Spread.BorderCollapse.Collapse;
            m_fpSpread.BorderStyle = System.Windows.Forms.BorderStyle.None;
            m_fpSpread.ClipboardOptions = FarPoint.Win.Spread.ClipboardOptions.NoHeaders;
            m_fpSpread.Dock = System.Windows.Forms.DockStyle.Fill;
            m_fpSpread.Location = new System.Drawing.Point(0, 0);
            m_fpSpread.Name = "m_fpSpread";
            m_fpSpread.Sheets.AddRange(new FarPoint.Win.Spread.SheetView[] { m_fpSpread_Sheet });
            m_fpSpread.Size = new System.Drawing.Size(1005, 413);
            m_fpSpread.TabIndex = 0;
            m_fpSpread_Sheet.Reset();
            m_fpSpread_Sheet.SheetName = "Sheet1";
            m_fpSpread_Sheet.ReferenceStyle = FarPoint.Win.Spread.Model.ReferenceStyle.R1C1;
            m_fpSpread_Sheet.OperationMode = FarPoint.Win.Spread.OperationMode.ReadOnly;
            m_fpSpread_Sheet.ReferenceStyle = FarPoint.Win.Spread.Model.ReferenceStyle.A1;
            ((System.ComponentModel.ISupportInitialize)(this.m_fpSpread_Sheet)).EndInit();
            //设置打印选项
            m_fpSpread.ActiveSheet.ColumnHeader.Visible = false;
            m_fpSpread.ActiveSheet.RowHeader.Visible = false;
            var info = new PrintInfo();
            info.Orientation = PrintOrientation.Landscape;//横向打印
            //指定页边矩，按照普通页面设置：上下各2.54cm，左右个3.18/2cm
            info.Margin = new PrintMargin(50, 25, 25, 25, 0, 0);
            info.ShowBorder = false;//是否显示表格边框
            info.ShowGrid = false;
            info.PrintToPdf = true;
            info.PdfWriteMode = FarPoint.Win.Spread.PdfWriteMode.New;
            info.PdfWriteTo = FarPoint.Win.Spread.PdfWriteTo.File;
            info.PdfFileName = "test.pdf";
            info.Preview = false;
            info.AbortMessage = "打印结束";
            //设置强制分页符
            m_fpSpread.ActiveSheet.SetRowPageBreak(1, true);
            m_fpSpread.ActiveSheet.PrintInfo = info;
            //打印数据到内存
            LoadPrintData();
           
            this.Controls.Add(m_fpSpread);
            //开始打印
            m_fpSpread.PrintSheet(m_fpSpread.ActiveSheetIndex); 

           
        }

        private void LoadPrintData()
        {
            int columns = 4 ;
            int pageRows = 10;//每页的行数
            int pages = 4;//每页固定显示4个孔道数据
            int rows = 15 * pages ;
            m_fpSpread.ActiveSheet.Rows.Count = rows;

            //设置具有特殊要求的行高和列宽，默认行高为20，列宽为60
            for (int pageNo = 0; pageNo < pages; pageNo++)
            {
                for (int row = pageNo * pageRows; row < pageNo * pageRows + pageRows; row++)
                {
                    if (row == 0 + pageNo * pageRows)//第1行
                        m_fpSpread.ActiveSheet.Rows[row].Height = 40;
                    else if (row == pageNo * pageRows + pageRows - 4 || row == pageNo * pageRows + pageRows - 3 || row == pageNo * pageRows + pageRows - 2)//倒数第2、3、4行
                        m_fpSpread.ActiveSheet.Rows[row].Height = 25;
                    else if (row == 12 + pageNo * pageRows)//详细数据表头行
                        m_fpSpread.ActiveSheet.Rows[row].Height = 35;
                    else if (row == pageNo * pageRows + pageRows - 1)//倒数第1行
                        m_fpSpread.ActiveSheet.Rows[row].Height = 25;
                    else if (row > pageNo * pageRows + 13 && row < (pageNo * pageRows + pageRows - 4))//中间的数据区
                        m_fpSpread.ActiveSheet.Rows[row].Height = 35;
                    else
                        m_fpSpread.ActiveSheet.Rows[row].Height = 22;
                }
            }
            for (int col = 0; col < columns; col++)
            {
                if (col == 2 || col == 3)
                    m_fpSpread.ActiveSheet.Columns[col].Width = 45;
                else if (col == columns - 1 || col == columns - 2 || col == columns - 3 || col == columns - 4 || col == columns - 5 || col == columns - 6 || col == columns - 7)
                    m_fpSpread.ActiveSheet.Columns[col].Width = 43;
                else
                    m_fpSpread.ActiveSheet.Columns[col].Width = 35;
            }
            //开始分页设置打印数据
            for (int pageNo = 0; pageNo < pages; pageNo++)
            {
                LoadPrintDataRetail(pageNo, pages);
            }
        }

        /// <summary>
        /// 打印表尾
        /// </summary>
        /// <param name="pageNo">当前页号</param>
        /// <param name="pageNum">总页数</param>
        private void LoadPrintDataRetail(int pageNo, int pageNum)
        {
            int columns = 4 ;
            int rowNo = pageNo;
            //=================================表尾开始==============================
            //========================================倒数第4行=====================================
            //倒数第4行0列，自检意见/内容
            int aver = (columns - 6) / 3;//均分
            m_fpSpread.ActiveSheet.AddSpanCell(rowNo, 0, 3, 2);
            m_fpSpread.ActiveSheet.Cells[rowNo, 0].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 0].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 0].Value = "自检意见";
            m_fpSpread.ActiveSheet.Cells[rowNo, 2].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;

            //倒数第4行，监理意见/内容
            m_fpSpread.ActiveSheet.AddSpanCell(rowNo, 2 + aver, 3, 2);
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver].Value = "监理意见";
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;

            //倒数第4行，原始记录本/内容
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver].Value = "原始记录本";

            //倒数第4行，表号/内容
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver + 1].Value = "表号";
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver + 1 + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo, 2 + aver + 2 + aver + 1 + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            //倒数第3行，册号/内容
            m_fpSpread.ActiveSheet.Cells[rowNo + 1, 2 + aver + 2 + aver + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 1, 2 + aver + 2 + aver + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 1, 2 + aver + 2 + aver + 1].Value = "册号";
            m_fpSpread.ActiveSheet.Cells[rowNo + 1, 2 + aver + 2 + aver + 1 + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 1, 2 + aver + 2 + aver + 1 + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            //倒数第2行，页码/内容
            int aver1 = (columns - 7 - 2 * aver) / 2;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1].Value = "页码";
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            //倒数第2行，序号/内容
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1 + aver1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1 + aver1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1 + aver1].Value = "序号";
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1 + aver1 + 1].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Center;
            m_fpSpread.ActiveSheet.Cells[rowNo + 2, 2 + aver + 2 + aver + 1 + 1 + aver1 + 1].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Center;
            //=================================表尾结束==============================
            //===================最后1行=============================================
            //施工员
            aver = columns / 4;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 0].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 0].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 0].Value = "施工员：";
            //专业工程师
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, aver].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, aver].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, aver].Value = "专业工程师：";
            //质检工程师
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 2 * aver].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 2 * aver].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 2 * aver].Value = "质检工程师：";
            //监理工程师
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 3 * aver].VerticalAlignment = FarPoint.Win.Spread.CellVerticalAlignment.Bottom;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 3 * aver].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Left;
            m_fpSpread.ActiveSheet.Cells[rowNo + 3, 3 * aver].Value = "监理工程师：";
        } 
    }
}
